
	subroutine arc(x1,y1,coc1,sic1,x2,y2,coc2,sic2,s)
C--------------------------------------------------------------------------
C-- Subroutine arc calculate the signed arc length between two points
C-- (x1,y1) and (x2,y2) starting from (x1,y1) using Hermite interpolation
C-- and Simpson's rule. So it is third order accurate.

	implicit real*8 (a-h,o-z)

C----- Coordinates transform

	x3 = (x2 - x1)* coc1 + (y2 - y1) *sic1
	y3 = -(x2 - x1)*sic1 + (y2 - y1) * coc1
	coc3 = coc2*coc1 + sic2*sic1
	sic3 = -coc2*sic1 + sic2*coc1

C----- Determine the Hermite cubic

	if( abs(y3) .le. 1.0d-8) then 
	  s = dsqrt( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) )
	else
	     !# the curve is   $ \xi = c \eta^2 + d \eta^3$
 	  c = 3.0d0*x3/(y3*y3) + sic3/(y3*coc3)
 	  d =  -sic3/(coc3*y3*y3) - 2.0d0*x3/(y3*y3*y3)

C---- Using the simpson rule --------------------

	  ymid = y3*0.5d0
	  ymid1 = ymid1*ymid1
	  fmid = dsqrt( 1.0d0 + ymid1* (2.0d0*c + 3.0d0*d*ymid)*
     1		(2.0d0*c + 3.0d0*d*ymid) )
	  f2 = dsqrt( 1.0d0 + y3*y3* (2.0d0*c + 3.0d0*d*y3)*
     1          (2.0d0*c + 3.0d0*d*y3) )
	  s= (1.0d0 + 4.0d0*fmid + f2 )*y3/6.0d0
	endif

	return
	end

