
	subroutine copymat(m,n,x,y)
        implicit double precision (a-h,o-z)
        dimension x(m+1,n+1),y(m+1,n+1)

        do 10 j=1,n+1
          do 20 i=1,m+1
                x(i,j) = y(i,j)
 20     continue
 10     continue

        return
        end

C*******************************************************************************

        subroutine matcopy(m,n,u1,u)
        implicit real*8(a-h,o-z)
        dimension u(0:m,0:n),u1(0:m,0:n)
 
        do j=0,n
           do i=0,m
              u1(i,j) = u(i,j)
           enddo
        enddo
 
        return
        end

C*******************************************************************************
 
        subroutine dgltsl(n,c,d,e,b,work1,work2,work3)

C*******************************************************************************
C
C  dgltsl DECOMPOSE and solve the almost tridiagonal linear system with
C  the extra elements on (1,n) and (n,1). This routine calls cmlib dgtsl.
C
C   n   on entry, the dimension of the system.
C   d   double d(n) the diagonal  elements. On output d is destroyed.
C   c   double c(2),...,c(n) are the subdiagonal elements and c(1) is
C       the elements at (1,n). On output c is destroyed.
C   e   double e(1),e(2),..., e(n-1) are the superdiagonal elements and
C       e(n) is the elements at (n,1). On output e is destroyed.
C   b   double the right hand vector. On return it is the solution.
C   work1, work2, work3    double working spaces.
C
C*******************************************************************************

        implicit double precision (a-h,o-z)
        dimension d(n),b(n),c(n),e(n), work1(n),work2(n),work3(n)

        call copyvec(n,work1,c)
        call copyvec(n,work2,d)
        call copyvec(n,work3,e)

C  First we solve the n-1 system:
C  c(i)*y(i-1) + d(i)*y(i) + e(i)*y(i+1) = b(i), i = 1,2, ..., n-1
C  with y(0), y(n) = 0.

        call dgtsl(n-1,c,d,e,b,info)

C  Next we solve the n-1 system:
C  c(i)*z(i-1) + d(i)*z(i) + e(i)*z(i+1) = 0, i = 1,2, ..., n-1
C  with z(0)=y(n) = 1.

        do 10 i=1,n-1
            e(i) = 0.0d0
 10     continue
        e(1) = -work1(1)
        e(n-1) = -work3(n-1)

        call dgtsl(n-1,work1,work2,work3,e,info)

C  Then the solution x can be expressed
C  x = y + alf z.  alf is determined by the last equation.

        alf = b(n) - e(n)*b(1) - c(n)*b(n-1)
        b(n) = alf/(work2(n)+c(n)*e(n-1)+e(n)*e(1) )

        do 20 i=1,n-1
           b(i) = b(i) + b(n)*e(i)
 20     continue

        return
        end

C-------------------------------------------------------------------------------

        subroutine copyvec(n,a,b)
C
C    copyvec copys the vector b into a.

        implicit double precision (a-h,o-z)
        dimension a(n),b(n)

        do 10 i=1,n
           a(i) = b(i)
 10     continue

        return
        end

C*******************************************************************************

        double precision function prod(n,x,y)
        implicit real*8 (a-h,o-z)

        dimension x(n),y(n)

        prod = 0.0d0
        do i=1,n
          prod = prod + x(i)*y(i)
        enddo

        return
        end

