
	subroutine fjump(m,n,n1,n2,i,j,index,index2,h,a,b,c,d,phi,uj,x,y
     1                  ,cinfo,coc,sic,curv,x1,y1,uji,ujd,ujdd,svdc2)
        parameter( nl = 6)
        implicit real*8(a-h,o-z)

C*************************************************************************
C   This routine evaluate the jump information [u], [u]', [u]'',
c   at a point (x1,y1) on the interface which is the projection of an 
c   irregular grid point using the weighted least squares
c   interpolation, assuming [u_n] = 0.
c   Input information:
c
c   Onput information:
c     uji,ujd,ujdd, are the jumps of [u], [u]', [u]'',
C -----------------------------------------------------------------------

	dimension phi(0:m,0:n),x(0:m),y(0:n),index(0:m,0:n)
     1		  ,index2(0:m,0:n),cinfo(n1,10),uj(n2),svdc2(n1,6,3)

        pi = 3.14159265358979d0
        alf=2.1d0*h
        if0 = int(alf/h) + 1
 
        i0 = int((x1-a)/h)
        j0 = int((y1-c)/h)

        il = max(0,i- if0)
        iu = min(m,i + if0)
        jl = max(0,j - if0)
        ju = min(n,j + if0)

C------------------ Summarize to get u_j' and u_j'' ------------------
 
	uji = 0.0d0
        ujd = 0.0d0
	ujdd = 0.0d0
        nsub = 0
 
        do 75 i2=0, if0       !# Starting from the center
        do 40 i1 = i0-i2,i0+i2
          do 40 j1 = j0-i2, j0+i2
           if( abs(i1-i0) + abs(j1-j0) .eq. i2.and. index2(i1,j1)
     1          .gt. 0) then      !# outside irregular point
             nn1 = index(i1,j1)
             x2 = cinfo(nn1,1)
             y2 = cinfo(nn1,2)
             coc2 = cinfo(nn1,3)
             sic2 = cinfo(nn1,4)
             call arc(x1,y1,coc,sic,x2,y2,coc2,sic2,s)
             ts = abs(s)
           if(ts .lt. alf .and. nsub .lt. nl) then
	     n22 = index2(i1,j1)
	     nn2 = index(i,j)
             ts = 1.0+dcos(pi*ts/alf)
             nsub = nsub + 1
c            ujd = ujd + w3(nsub)*ts*uj(n22)
c	     ujdd = ujdd + w3b(nsub)*ts*uj(n22)
c	     uji = uji + w3c(nsub)*ts*uj(n22)
 	      ujd = ujd + svdc2(nn2,nsub,1)*uj(n22)
 	     ujdd = ujdd + svdc2(nn2,nsub,2)*uj(n22)
 	     uji = uji + svdc2(nn2,nsub,3)*uj(n22)
           endif
        endif
   40   continue

	n22 = index2(i,j)
	if(n22 .gt. 0.0) uji=uj(n22)
 
   75   continue
        return
        end

