
	subroutine gmres(n1max,mm,m,n,n1,n2,imax,a,b,c,d,h,phi,x,y,
     1		cinfo,index,index2,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2		elmbda,idimf,work,uj,unj,u,f,x0,v,hg,bf,tol
     3		,svdc1,svdc2,iter,error)

	parameter(nn=1000)

        implicit real*8 (a-h,o-z)

        dimension x0(n2),bf(n2),r(nn),v(n1max,mm),hg(n1max,mm),s(nn)
     1  	 ,x11(nn),vk(nn),w(nn),hj(nn,2),yy(nn)
     2           ,x(0:m),y(0:n),f(0:m,0:n), u(0:m,0:n)
     3	         ,phi(0:m,0:n),index(0:m,0:n),index2(0:m,0:n),
     4		 bda(0:n),bdb(0:n),bdc(0:m),bdd(0:m),cinfo(n1,10)
     5		,work(2*(m+1)*(n+1)),uj(n2),unj(n2),svdc1(n2,16)
     6		,svdc2(n1,6,3)

 	iter = 0
	do 10 j=1,imax

	   do j1=1,n-1
	     do i=1,m-1
		u(i,j1) = f(i,j1)
	     enddo
	   enddo

	   ser0 = 0.0
	   call matvec1(m,n,n1,n2,a,b,c,d,h,phi,x,y,cinfo,svdc1
     1          ,svdc2,u,index,index2,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2          elmbda,idimf,work,uj,unj,x0,yy,bf)
 
	   call resid(n2,yy,bf,r)

	   dr1 = dsqrt(prod(n2,r,r))
c	write(*,*)'n2 ', n2, dr1
	   if(dr1 .le. 1e-12)return

	   do i=1,n2
	      v(i,1) = r(i)/dr1
	      s(i) = 0.0d0
	   enddo

	   s(1) = dr1

C---------------- For i=1,2, ..., mm ------------------------------
	   do i=1,mm-1
	     iter = iter + 1
	     do i1=1,n2
		vk(i1) = v(i1,i)
	     enddo

	     do j2=1,n-1
	       do i2=1,m-1
		  u(i2,j2) = f(i2,j2)
	       enddo
	     enddo

	     call matvec1(m,n,n1,n2,a,b,c,d,h,phi,x,y,cinfo,svdc1
     1          ,svdc2,u,index,index2,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2          elmbda,idimf,work,uj,unj,vk,w,bf)
 
C---------------------------------------------------------------

	do k=1,i
	   do i1=1,n2
	      vk(i1) = v(i1,k)
	   enddo

 	   hg(k,i) = prod(n2,w,vk)

	   do i1=1,n2
	      w(i1) = w(i1) - hg(k,i)*vk(i1)
	   enddo
	enddo 

	hg(i+1,i) = dsqrt(prod(n2,w,w))

	if( abs(hg(i+1,i)) .le. 1e-14) then
	   infon = 1
	else
	   infon = 0
           do i1=1,n2
              v(i1,i+1) = w(i1)/hg(i+1,i)
           enddo
	endif

C----------------------------------------------------------------

C----- Apply J_1, j_2, ..., J_{i-1} on (hg_{1,i}, ..., hg_{i+1,i} ---------
C   Suppose J_i =
C			| I 0 |    p = | cos(\alf)  sin(\alf) |
C			| 0 P |	       | -sin(\alf) cos(\alf) |
C
C	cos(\alf) = hg(i,i)/sqrt(hg(i,i)^2 + hg(i+1,i)^2)
C	sin(\alf) = hg(i+1,i)/sqrt(hg(i,i)^2 + hg(i+1,i)^2)

C------- Form J_i so that the (i+1)th component of J_i*h(:,i) is zero.

        do k=1,i-1
          hit = hj(k,1)* hg(k,i) + hj(k,2)*hg(k+1,i)
          hg(k+1,i) = -hj(k,2)*hg(k,i) + hj(k,1)*hg(k+1,i)
          hg(k,i) = hit
        enddo

	if(infon .eq.0) then
	
	dt = dsqrt(hg(i,i)*hg(i,i)+hg(i+1,i)*hg(i+1,i))
	hj(i,1) = hg(i,i)/dt
	hj(i,2) = hg(i+1,i)/dt
	st = hj(i,1)*s(i) + hj(i,2)*s(i+1)
	s(i+1) = -hj(i,2)*s(i) + hj(i,1)*s(i+1)
	s(i) = st

          hit = hj(i,1)* hg(i,i) + hj(i,2)*hg(i+1,i)
          hg(i+1,i) = -hj(k,2)*hg(i,i) + hj(i,1)*hg(i+1,i)
          hg(i,i) = hit

	endif

	ser1 = abs(s(i+1))
c       write(*,*)'***', i, ser1

	if (ser1 .gt. 1.0d-15) then
	   serr = abs((ser1-ser0)/ser1)
	else
	   serr = 0.0
	endif

 	if(ser1 .le. tol .or. serr .le. tol) then
	   serr = tol - 1.0e-15
	   mi = i
	   goto 100
	endif

	  ser0 = ser1

	enddo
	   mi = mm-1

C-------------- end loop for i=1,2,...mm---------------------------------

C--------------- Update(x_i,i) ------------------------------------------

 100 	yy(mi) = s(mi)/(hg(mi,mi)+1.0d-14)
c100    yy(mi) = s(mi)/hg(mi,mi)

	do k=mi-1,1,-1
	   yy(k) = s(k)
	   do j1 = k+1,mi
	     yy(k) = yy(k) - hg(k,j1)*yy(j1)
	   enddo
	   yy(k) = yy(k)/hg(k,k)
	enddo	

	do i=1,n2
	  x11(i) = x0(i)
	  do k=1,mi
	     x11(i) = x11(i) + yy(k)*v(i,k)
	  enddo
	enddo

	do j2=1,n-1
	  do i2=1,m-1
	    u(i2,j2) = f(i2,j2)
	  enddo
	enddo

	call matvec1(m,n,n1,n2,a,b,c,d,h,phi,x,y,cinfo,svdc1
     1          ,svdc2,u,index,index2,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2          elmbda,idimf,work,uj,unj,x11,w,bf)

	call resid(n2,w,bf,r)
	s(mi+1) = dsqrt(prod(n2,r,r))

	  do k=1,n2
            x0(k) = x11(k)
          enddo

 	if( abs(s(mi+1)) .lt. tol .or. serr .lt. tol ) return

	error = s(mi+1)
	   
 10	continue

	return
	end

C*******************************************************************************  
	subroutine resid(n,x,b,r)
        implicit double precision (a-h,o-z)
        
        dimension x(n), b(n), r(n)

	do i=1,n
	   r(i) = b(i) - x(i)
	enddo
        return
        end

