
        subroutine normal(m,n,a,b,c,d,h,x1,y1,x,y,phi,coc,sic,curv)
	implicit double precision (a-h,o-z)

C-- subroutine normal finds the tangential, normal, curvature information 
C   at a given point on the interface, it may not be a grid point.
C   Input:  m,n,a,b,c,d,h,x,y,phi
C           see the description in the subroutine iim_poisson.f
C      x1,y1:  A point on the interface.
C   Output: coc,sic,curv,
C           the normal direction and curvature at (x1,y1)
 
        dimension phi(0:m,0:n),x(0:m),y(0:n)

	i = int((x1-a)/h)
	j = int((y1-c)/h)

	call phiinf(m,n,i,j,h,phi,phx1,phy1,phxx1,phyy1,phxy1)
	call phiinf(m,n,i+1,j,h,phi,phx2,phy2,phxx2,phyy2,phxy2)
	call phiinf(m,n,i,j+1,h,phi,phx3,phy3,phxx3,phyy3,phxy3)
	call phiinf(m,n,i+1,j+1,h,phi,phx4,phy4,phxx4,phyy4,phxy4)

C----- Begin nilinear interpolation -------------------------

	ht = 2.0/h
	x0 = 1.0 -( (x1-x(i))*ht -1.0)
	y0 = 1.0 -( (y1-y(j))*ht -1.0)
	xe = 1.0 + ( (x1-x(i)) *ht -1.0)
	ye = 1.0 + ( (y1-y(j)) *ht -1.0)

	phx0 = 0.25*(phx1*x0*y0+phx2*xe*y0+phx3*x0*ye+phx4*xe*ye)
	phy0 = 0.25*(phy1*x0*y0+phy2*xe*y0+phy3*x0*ye+phy4*xe*ye)
	phxx0 = 0.25*(phxx1*x0*y0+phxx2*xe*y0+phxx3*x0*ye+phxx4*xe*ye)
	phyy0 = 0.25*(phyy1*x0*y0+phyy2*xe*y0+phyy3*x0*ye+phyy4*xe*ye)
	phxy0 = 0.25*(phxy1*x0*y0+phxy2*xe*y0+phxy3*x0*ye+phxy4*xe*ye)	

        phn = phx0*phx0 + phy0 *phy0
        phn1 = dsqrt(phn)
	coc = phx0/phn1
	sic = phy0/phn1

C----- Compute the Curvature --------------------

        t1 = phx0*phx0
        t2 = phy0*phy0
 
        curv = phxx0*t2 - 2.0*phxy0*phx0*phy0 + phyy0*t1
        tem = (t1+t2)**1.5d0
        curv = -curv/tem

        return
        end

C--------------------------------------------------------------

        subroutine curt(phx,phy,phxx,phxy,phyy,coc,sic,curv)
        implicit double precision (a-h,o-z)
 
               phn = phx*phx + phy *phy
               phn = dsqrt(phn)
               coc = phx/phn
               sic = phy/phn
 
               t1 = phx*phx
               t2 = phy*phy
 
               curv = phxx*t2 - 2.0*phxy*phx*phy + phyy*t1
               tem = (t1+t2)**1.5d0
               curv = -curv/tem
 
        return
        end

