
	subroutine poisson(m,n,n1,n2,a,b,c,d,h,phi,x,y,cinfo
     1  	,f,index,index2,uj,unj,mbdcnd,bda,bdb,nbdcnd,bdc,bdd,
     2		elmbda,idimf,work,svdc2)
        implicit real*8(a-h,o-z)
 
C*************************************************************************
C   This subroutine set-up the correction terms and solve the Poisson/
C   Helmholtz equation with given jumps.
C -----------------------------------------------------------------------
 
        dimension phi(0:m,0:n),x(0:m),y(0:n),index(0:m,0:n),
     1 		index2(0:m,0:n),uj(n2),f(0:m,0:n),unj(n2)
     2         ,bda(0:n),bdb(0:n),bdc(0:m),bdd(0:m)
     3		,cinfo(n1,10),work(2*(m+1)*(n+1)),svdc2(n1,6,3)

C----------- Deal with irregular grid points ------------------

	h1 = h*h

	etrun = 0.0
        do 10 j=1,n-1
           do 20 i=1,m-1
             if(index(i,j) .ge. 1) then          !# if irregular
	       nn1 = index(i,j)
               n22 = index2(i,j)
               x1 = cinfo(nn1,1)
               y1 = cinfo(nn1,2)
               coc = cinfo(nn1,3)
               sic = cinfo(nn1,4)
	       curv = cinfo(nn1,5)
               corr = 0.0d0
	       call fjump(m,n,n1,n2,i,j,index,index2,h,a,b,c,d,phi,uj,x,y,
     1             cinfo,coc,sic,curv,x1,y1,uji,ujd,ujdd,svdc2)

	       cinfo(nn1,6) = uji
	       cinfo(nn1,7) = ujd
	       cinfo(nn1,8) = ujdd

 	       call fjump(m,n,n1,n2,i,j,index,index2,h,a,b,c,d,phi,unj,x,y,
     1             cinfo,coc,sic,curv,x1,y1,unji,unjd,unjdd,svdc2)

	       cinfo(nn1,9) = unji
	       cinfo(nn1,10) = unjd

               uxj = unji*coc - ujd*sic
               uyj = unji*sic + ujd*coc
               uxxjt = curv*unji - ujdd + fji(x1,y1)-elmbda*uji*0.0
               uxyjt = ujd*curv + unjd
               uyyjt = -unji*curv + ujdd
               uxxj = uxxjt*coc*coc -2.0*uxyjt*coc*sic+uyyjt*sic*sic
               uyyj = uxxjt*sic*sic +2.0*uxyjt*coc*sic+uyyjt*coc*coc
               uxyj = (uxxjt-uyyjt)*coc*sic +uxyjt*(coc*coc-sic*sic)

C------ Compute the correction terms, only add correction terms
C       from the grid points from other side        ------------------
                xt = x(i-1)-x1
                yt = y(j)-y1
                if(phi(i,j) .le. 0.0 .and. phi(i-1,j) .gt. 0) then
                   corr = corr + uji+ uxj*xt+uyj*yt+0.5*uxxj*xt*xt
     1                           + uxyj*xt*yt + uyyj*yt*yt*0.5
                endif
                if(phi(i,j) .gt. 0.0 .and. phi(i-1,j) .le. 0) then
                   corr = corr - uji- uxj*xt-uyj*yt-0.5*uxxj*xt*xt
     1                          - uxyj*xt*yt - uyyj*yt*yt*0.5
                endif     !#  1-st point

                xt = x(i+1)-x1
                if(phi(i,j) .le. 0.0 .and. phi(i+1,j) .gt. 0) then
                   corr = corr + uji+ uxj*xt+uyj*yt+0.5*uxxj*xt*xt
     1                           + uxyj*xt*yt + uyyj*yt*yt*0.5
                endif
                if(phi(i,j) .gt. 0.0 .and. phi(i+1,j) .le. 0) then
                   corr = corr - uji- uxj*xt-uyj*yt-0.5*uxxj*xt*xt
     1                           - uxyj*xt*yt - uyyj*yt*yt*0.5
                endif     !# 2-nd point
 
                xt = x(i)-x1
                yt = y(j-1)-y1
                if(phi(i,j) .gt. 0.0 .and. phi(i,j-1) .le. 0) then
                   corr = corr - uji- uxj*xt-uyj*yt-0.5*uxxj*xt*xt
     1                           - uxyj*xt*yt - uyyj*yt*yt*0.5
                endif
                if(phi(i,j) .le. 0.0 .and. phi(i,j-1) .gt. 0) then
                   corr = corr + uji+ uxj*xt+uyj*yt+0.5*uxxj*xt*xt
     1                           + uxyj*xt*yt + uyyj*yt*yt*0.5
                endif     !#  3-rd point
 
                yt = y(j+1)-y1
                if(phi(i,j) .le. 0.0 .and. phi(i,j+1) .gt. 0) then
                   corr = corr + uji+ uxj*xt+uyj*yt+0.5*uxxj*xt*xt
     1                           + uxyj*xt*yt + uyyj*yt*yt*0.5
                endif
                if(phi(i,j) .gt. 0.0 .and. phi(i,j+1) .le. 0) then
                   corr = corr - uji- uxj*xt-uyj*yt-0.5*uxxj*xt*xt
     1                           - uxyj*xt*yt - uyyj*yt*yt*0.5
                endif     !# 4-th point

	        f(i,j) = f(i,j) + corr/h1	
 
             endif      !# end if irregular

 20        continue
 10     continue

c	elmbda = 1.0
        call hwscrt(a,b,m,mbdcnd,bda,bdb,c,d,n,nbdcnd,bdc,bdd,
     1                   elmbda,f,idimf,pertrb,ierror,work)
 
        return
        end

	
