
C-----------------------------------------------------------------

	subroutine project(m,n,h,i,j,x,y,x1,y1,phi)
        implicit double precision (a-h,o-z)

C-- subroutine project find the projection of the interface of a given
C   grid point (x_i,y_j)
C
C   Input: m,n,h,i,j,x,y,phii
C           see the description in the subroutine iim_poisson.f
C   Output: x1,y1 the projection on the interface of (x(i),y(j)).

	dimension phi(0:m,0:n),x(0:m),y(0:n)

C   Compute the deepest descent direction (-grad phi(i,j,k)), then
C   locates the control points on the level set ----------------------
 
	call phiinf(m,n,i,j,h,phi,phx,phy,phxx,phyy,phxy)
 
        phn = phx*phx + phy *phy
        phn1 = dsqrt(phn)
        a0 = phi(i,j)
        a1 = -phn
        a2 =( phxx*phx*phx+2.0*phxy*phx*phy+phyy*phy*phy)*0.5
        call rootp2(a0,a1,a2,r1,r2,info)

C------------ if no real root is found, function may be too bad -----

	if( info .eq. 0) then
	   if(phi(i,j)*phi(i+1,j) .lt. 0.0) then
	     y1 = y(j)
	     x1 = x(i) + h*phi(i,j)/(phi(i,j)-phi(i+1,j))
	     return
	   endif
           if(phi(i,j)*phi(i-1,j) .lt. 0.0) then
             y1 = y(j)
             x1 = x(i) - h*phi(i,j)/(phi(i,j)-phi(i-1,j))
             return
	   endif

           if(phi(i,j)*phi(i,j+1) .lt. 0.0) then
             x1 = x(i)
             y1 = y(j) + h*phi(i,j)/(phi(i,j)-phi(i,j+1))
             return
           endif
           if(phi(i,j)*phi(i,j-1) .lt. 0.0) then
	     x1 = x(i)
             y1 = y(j) - h*phi(i,j)/(phi(i,j)-phi(i,j-1))
             return
           endif

	endif

C----------------- end -----------------------------------------
	
        r3 = min(r1,r2)*1.0
        r4 = max(r1,r2)*1.0
 
        if(phi(i,j) .ge. 0.0) then
           if(r3 .ge. 0.0) then
              r5 = r3
           else
              r5 = r4
           endif
        else
           if(r4 .le. 0.0) then
              r5 = r4
           else
              r5 = r3
           endif
        endif
        x1 = x(i) - r5*phx
        y1 = y(j) - r5*phy

	return
	end
