
	subroutine svd1(m,n,n1,n2,index,index2,h,a,b,c,d,phi,
     1  	x,y,cinfo,svdc1)
	parameter( nl = 16, ne=6)

C--------------------------------------------------------------------------
C-- Subroutine interp3 interpolates u_n^- and u_n^+ of the solution
C-- of Poisson equation with jumps along interface at (x1,y1) which is a
C-- point on the interface. The method is the weighted least squares 
C-- interpolation.
C--
C-- m,n:          The number of grid in the x- and y-direction.
C-- x1,y1:        A point on the interface where the interpolation 
C--               take place.
C-- u(0:m,0:n):   The grid function to be interpolated.
C--------------------------------------------------------------------------

        implicit real*8 (a-h,o-z)

        dimension x(0:m),y(0:n),phi(0:m,0:n)
     1	  ,index(0:m,0:n),index2(0:m,0:n),cinfo(n1,10)
     2    ,w1(ne,nl),w2(nl,2),w3(nl),sd(ne+1),ew(nl),uw(ne,ne),v(nl,nl)
     3          ,w4(ne),svdc1(n2,16)

	pi = 3.14159265358979d0
	alf=2.6d0*h
	if0 = int(alf/h) + 1

	do  100 j=1,n-1
          do 100 i=1,m-1
             nn1 = index(i,j)
             n22 = index2(i,j)
             if(n22 .gt. 0) then
               x1 = cinfo(nn1,1)
               y1 = cinfo(nn1,2)
               coc = cinfo(nn1,3)
               sic = cinfo(nn1,4)
               curv = cinfo(nn1,5)

        i0 = int((x1-a)/h)
        j0 = int((y1-c)/h)
	
C------------------- Initialize --------------------------------------------

           do ii=1,nl
              do jj=1,nl
		v(ii,jj) = 0.0d0
              enddo
	      do jj=1,ne
	        w1(jj,ii) = 0.0d0
	      enddo
           enddo

C------------------------- Generate the matrix --------------------------

	nsub = 0
	do 70 i2=0, if0       !# Starting from the center
	do 10 i1 = i0-i2,i0+i2
	  do 10 j1 = j0-i2, j0+i2
	   if( abs(i1-i0) + abs(j1-j0) .eq. i2) then     !# if A

	     t = (x(i1)-x1)*(x(i1)-x1)+(y(j1)-y1)*
     1                  (y(j1)-y1)
                ts = dsqrt(t)
           if(ts .lt. alf .and. nsub .lt. nl) then	  !# if B
	     ts = 1.0+dcos(pi*ts/alf)
	     nsub = nsub + 1
           call trans(x1,y1,x(i1),y(j1),w2(nsub,1),w2(nsub,2),coc,sic)
           w1(1,nsub) = ts
           w1(2,nsub) = w2(nsub,1)*ts
           w1(3,nsub) = w2(nsub,2)*ts
           w1(4,nsub) = 0.5*w2(nsub,1)*w2(nsub,1)*ts
           w1(5,nsub) = 0.5*w2(nsub,2)*w2(nsub,2)*ts
           w1(6,nsub) = w2(nsub,1)*w2(nsub,2)*ts

C---------- End coordinates transformation -------------------------------

	   endif					!# end if B

	   endif					!# end if A.
   10	continue
   70	continue

C----------------- Call least square routine --------------------------

        job = 11
        call dsvdc(w1,ne,ne,nsub,sd,ew,uw,ne,v,nl,w4,job,inf)
	
        do i1=1,ne
	   if(abs(sd(i1)) .gt. 1.0d-13) then
	       ew(i1)=uw(1,i1)/sd(i1)
	   else
	       ew(i1)= 0.0d0
	   endif
        enddo

C---------------------- w3(i) is the solution -------------
        do i1=1,nl
          w3(i1) = 0.0
            do j1=1,ne
                w3(i1) = w3(i1) + v(i1,j1)*ew(j1)
            enddo
        enddo

	nsub = 0
	do 80 i2=0, if0 
        do 15  i1 = i0-i2,i0+i2
          do 15 j1 = j0-i2, j0+i2
           if( abs(i1-i0) + abs(j1-j0) .eq. i2) then     !# if A
             t = (x(i1)-x1)*(x(i1)-x1)+(y(j1)-y1)*
     1                  (y(j1)-y1)
             ts = dsqrt(t)

C-------------- Add corection term if the grid point is involved ----------

          if(ts .lt. alf .and. nsub .lt. nl) then
                 ts = 1.0+dcos(pi*ts/alf)
                 nsub = nsub + 1
		 nn2 = index2(i,j)
		 svdc1(nn2,nsub) = w3(nsub)*ts
          endif

            endif
  15	  continue
  80    continue

	  endif
  100 	continue

	return
	end



