
	subroutine svd2(m,n,n1,n2,i,j,index,index2,h,a,b,c,d,phi
     1	   ,x,y,svdc2,cinfo)
        parameter( nl = 6)
        implicit real*8(a-h,o-z)

C*************************************************************************
C   This routine evaluate the jump information [u], [u]', [u]'',
c   at a point (x1,y1) on the interface which is the projection of an 
c   irregular grid point using the weighted least squares
c   interpolation, assuming [u_n] = 0.
c   Input information:
c
c   Onput information:
c     uji,ujd,ujdd, are the jumps of [u], [u]', [u]'',
C -----------------------------------------------------------------------

	dimension phi(0:m,0:n),x(0:m),y(0:n),index(0:m,0:n)
     1		  ,ew2(nl),w3(nl),w3b(nl),index2(0:m,0:n)
     2	 	  ,w1(3,nl),sd(4),ew(nl),uw(3,3),v(nl,nl)
     3		  ,cinfo(n1,10),w3c(nl),ew3(nl),w4(10)
     4		  ,svdc2(n1,6,3)

        pi = 3.14159265358979d0
        alf=2.1d0*h
        if0 = int(alf/h) + 1

        do  100 j=1,n-1
          do 100 i=1,m-1
             nn1 = index(i,j)
             n22 = index2(i,j)
             if(nn1 .ge. 1) then
               x1 = cinfo(nn1,1)
               y1 = cinfo(nn1,2)
               coc = cinfo(nn1,3)
               sic = cinfo(nn1,4)
               curv = cinfo(nn1,5)

 
        i0 = int((x1-a)/h)
        j0 = int((y1-c)/h)

        il = max(0,i- if0)
        iu = min(m,i + if0)
        jl = max(0,j - if0)
        ju = min(n,j + if0)

C------------------ initialize --------------------

           do ii=1,nl
              do jj=1,nl
                v(ii,jj) = 0.0d0
              enddo
              do jj=1,3
                w1(jj,ii) = 0.0d0
              enddo
           enddo

C------------------------- Generate the matrix --------------------------
 
        nsub = 0
        do 70 i2=0, if0       !# Starting from the center
        do 10 i1 = i0-i2,i0+i2
          do 10 j1 = j0-i2, j0+i2
           if( abs(i1-i0) + abs(j1-j0) .eq. i2 .and. index2(i1,j1)
     1		.gt. 0) then 	  !# outside irregular point
	     nn1 = index(i1,j1)
	     x2 = cinfo(nn1,1)
	     y2 = cinfo(nn1,2)
	     coc2 = cinfo(nn1,3)
	     sic2 = cinfo(nn1,4)
	     call arc(x1,y1,coc,sic,x2,y2,coc2,sic2,s)
             ts = abs(s)
           if(ts .lt. alf .and. nsub .lt. nl) then
             ts = 1.0+dcos(pi*ts/alf)
             nsub = nsub + 1
 
             w1(1,nsub) = ts
             w1(2,nsub) = s*ts
             w1(3,nsub) = 0.5d0*s*s*ts
           endif
           endif
   10   continue
 
   70   continue

C----------------- Call least square routine --------------------------

        job = 11
        call dsvdc(w1,3,3,nsub,sd,ew,uw,3,v,nl,w4,job,inf)
 
        do i1=1,3
                 if(abs(sd(i1)) .gt. 1.0d-13) then
                   ew(i1)=uw(2,i1)/sd(i1)
		   ew2(i1)=uw(3,i1)/sd(i1)
		   ew3(i1)=uw(1,i1)/sd(i1)
                 else
                   ew(i1)= 0.0d0
		   ew2(i1)= 0.0d0
		   ew3(i1)=0.0d0
                 endif
        enddo

C---------------------- w3(i) is the solution -------------
        do i1=1,nl
          w3(i1) = 0.0
	  w3b(i1) = 0.0
	  w3c(i1) = 0.0
            do j1=1,3
                w3(i1) = w3(i1) + v(i1,j1)*ew(j1)
		w3b(i1) = w3b(i1) + v(i1,j1)*ew2(j1)
	        w3c(i1) = w3c(i1) + v(i1,j1)*ew3(j1)
            enddo
        enddo

C------------------ Summarize to get u_j' and u_j'' ------------------
 
	uji = 0.0d0
        ujd = 0.0d0
	ujdd = 0.0d0
        nsub = 0

        do 75 i2=0, if0       !# Starting from the center
        do 40 i1 = i0-i2,i0+i2
          do 40 j1 = j0-i2, j0+i2
           if( abs(i1-i0) + abs(j1-j0) .eq. i2.and. index2(i1,j1)
     1          .gt. 0) then      !# outside irregular point
             nn1 = index(i1,j1)
             x2 = cinfo(nn1,1)
             y2 = cinfo(nn1,2)
             coc2 = cinfo(nn1,3)
             sic2 = cinfo(nn1,4)
             call arc(x1,y1,coc,sic,x2,y2,coc2,sic2,s)
             ts = abs(s)
           if(ts .lt. alf .and. nsub .lt. nl) then
	     n22 = index2(i1,j1)
	     nn2 = index(i,j)
             ts = 1.0+dcos(pi*ts/alf)
             nsub = nsub + 1
	     svdc2(nn2,nsub,1) = w3(nsub)*ts
	     svdc2(nn2,nsub,2) = w3b(nsub)*ts
	     svdc2(nn2,nsub,3) = w3c(nsub)*ts
c            ujd = ujd + w3(nsub)*ts*uj(n22)
c     	     ujdd = ujdd + w3b(nsub)*ts*uj(n22)
c	     uji = uji + w3c(nsub)*ts*uj(n22)
           endif
        endif
   40   continue

c	n22 = index2(i,j)
c	if(n22 .gt. 0.0) uji=uj(n22)
 
   75   continue

          endif
  100   continue

        return
        end

